package test.excel;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.poi.poifs.filesystem.POIFSFileSystem;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFClientAnchor;
import org.apache.poi.xssf.usermodel.XSSFDrawing;
import org.apache.poi.xssf.usermodel.XSSFPicture;
import org.apache.poi.xssf.usermodel.XSSFRichTextString;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class WriteXSSF {
	
	
			
		private XSSFWorkbook workBook;
		private XSSFSheet sheet;
		private XSSFRow excelRow;
		private XSSFCell cell;
		
		private String excelFileName;
		private String sheetName;
		public WriteXSSF(String excelFileName,String sheetName) throws IOException
		{
			this.excelFileName=excelFileName;
			this.sheetName=sheetName;
			System.out.println("CHecking Whether the File exists");
			
			File fileIn=new File(excelFileName);
			System.out.println("The Input File Name:"+fileIn);
			FileInputStream fInputStream;
			if(fileIn.exists())
			{
				System.out.println("WorkBook is Exist / Getting the Existing Workbook");
				
				
					fInputStream = new FileInputStream(fileIn);
//					POIFSFileSystem poiStream=new POIFSFileSystem(fInputStream);
					workBook=new XSSFWorkbook(fInputStream);
					System.out.println("Getting The Existing Sheet From the Existing Workbook");
					sheet=workBook.getSheet(sheetName);
					System.out.println("THe WorkBook: "+workBook);
					System.out.println("THe Sheet: "+sheet);
//					System.out.println("THe Sheet: "+sheet.getSheetName());
//					sheet.getDrawingPatriarch();
					if(sheet==null)
					{
						System.out.println("Creating New Sheet in the Existing Workbook");
						sheet=workBook.createSheet(sheetName);
					}
					
			 
			}
			else
			{
				System.out.println("Creating New WorkBook and New Sheet");
				workBook=new XSSFWorkbook();
				sheet=workBook.createSheet(sheetName);
				System.out.println("THe WorkBook: "+workBook);
				System.out.println("THe Sheet: "+sheet);
				System.out.println("THe Sheet: "+sheet.getSheetName());
			}
		}
		public void insertData(int row,int col,String data)
		{
			System.out.println("Creating Row,Cell and inserting Data into WorkSheet");
			
				if(sheet!=null)
				{
					if(sheet.getRow(row)!=null)
					{
						excelRow=sheet.getRow(row);
					}
					else
					{
						excelRow=sheet.createRow(row);
					}

					cell=excelRow.createCell(col);
					cell.setCellType(XSSFCell.CELL_TYPE_STRING);
					cell.setCellValue(new XSSFRichTextString(data));
					sheet.autoSizeColumn(col);
					System.out.println("The Data is inserted successfully in WorkSheet");
				}
		}
		public void insertImage(int startRow,int startCol,int endRow,int endCol,String imgPath) throws IOException
		{
			System.out.println("Inserting Picture into WorkSheet");
			XSSFClientAnchor anchor;
			XSSFDrawing patriarch;
			XSSFPicture picture;
			FileInputStream fileInput=new FileInputStream(imgPath);
			ByteArrayOutputStream img_bytes=new ByteArrayOutputStream();
			int b;
			while((b=fileInput.read())!=-1)
			img_bytes.write(b);
			fileInput.close();
			anchor=workBook.getCreationHelper().createClientAnchor();
			int picIndex=workBook.addPicture(img_bytes.toByteArray(), XSSFWorkbook.PICTURE_TYPE_JPEG);
			anchor.setCol1(startCol);
			anchor.setRow1(startRow);
			anchor.setCol2(endCol);
			anchor.setRow2(endRow);
			anchor.setAnchorType(1);
			
			System.out.println("The Worbook  : "+workBook);
			System.out.println("The Sheet  : "+sheet);
			
//			System.out.println("THe Existing Sheet Patriarch: "+sheet.getDrawingPatriarch());
			
			patriarch=sheet.createDrawingPatriarch();
			
			System.out.println("THe PAtrich Val: "+patriarch);
			
			picture=patriarch.createPicture(anchor, picIndex);
//			pic.resize();
			System.out.println("The Image is inserted Successfully in workSheet");
		}

		public void writeDataToExcel() throws IOException 
		{	
			FileOutputStream outputExcelFile;
			System.out.println("Writing the workbook(cintains data) to Output Excel File");
				System.out.println(excelFileName);
				System.out.println("The length of excel file : "+excelFileName.length());
				outputExcelFile=new FileOutputStream(new File(this.excelFileName));
				workBook.write(outputExcelFile);
				System.out.println("THe Workbook is succesfully written to Output Excel File");	
					
				if(outputExcelFile!=null)
				{
					outputExcelFile.flush();
					outputExcelFile.close();
				} 
			}
		}




